## feel++ 0.91.1

=== CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8 -*-
#
#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-11-29
#
#  Copyright (C) 2009-2010 Université Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
cmake_minimum_required (VERSION 2.6)

# guard against in-source builds

if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
  message(FATAL_ERROR "In-source builds not allowed. Please make a new directory (called a build directory) and run CMake from there. You may need to remove CMakeCache.txt. ")
endif()

# guard against bad build-type strings

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_tolower)
if(    NOT cmake_build_type_tolower STREQUAL "debug"
   AND NOT cmake_build_type_tolower STREQUAL "release"
   AND NOT cmake_build_type_tolower STREQUAL "relwithdebinfo")
  message(FATAL_ERROR "Unknown build type \"${CMAKE_BUILD_TYPE}\". Allowed values are Debug, Release, RelWithDebInfo (case-insensitive).")
endif()


#SET( CMAKE_CXX_FLAGS "-pipe -Wall -O2 ")
#SET( CMAKE_C_FLAGS "-pipe -Wall -O2")

project (Feel++ C CXX Fortran)

macro(set_config_option VARNAME STRING)
  set(${VARNAME} TRUE)
  list(APPEND CONFIG_OPTIONS ${STRING})
  message(STATUS "Found " ${STRING})
endmacro(set_config_option)


OPTION(FEELPP_ENABLE_SVN "enable Feel++ looking up for svn information" OFF)
SET(FEELPP_SCM "svn")
FIND_PACKAGE(Subversion)
IF(FEELPP_ENABLE_SVN AND ( Subversion_FOUND AND EXISTS ${PROJECT_SOURCE_DIR}/.svn ) )
#IF ( Subversion_FOUND AND EXISTS ${PROJECT_SOURCE_DIR}/.svn )
  Subversion_WC_INFO(${PROJECT_SOURCE_DIR} Project)
  MESSAGE("Current revision is ${Project_WC_REVISION}")
  Subversion_WC_LOG(${PROJECT_SOURCE_DIR} Project)
  MESSAGE("Last changed log is ${Project_LAST_CHANGED_LOG}")
ELSE()
  FIND_PACKAGE(Git)
  if(FEELPP_ENABLE_SVN AND GIT_FOUND AND  EXISTS ${PROJECT_SOURCE_DIR}/.git )

    execute_process(
      COMMAND git rev-parse --verify -q --short git-svn
      WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
      OUTPUT_VARIABLE GIT_COMMIT
      ERROR_VARIABLE GIT_COMMIT_error
      RESULT_VARIABLE GIT_COMMIT_result)
    if ( NOT ${GIT_COMMIT_result} EQUAL 0 )
      MESSAGE(SEND_ERROR "Command \"git rev-parse --verify -q --short git-svn\" failed with output:\n${GIT_COMMIT_error}")
    else()
      STRING(STRIP "${GIT_COMMIT}" GIT_COMMIT )
      MESSAGE(STATUS "Git commit: ${GIT_COMMIT}")
    endif()
    execute_process(
      COMMAND git show --raw ${GIT_COMMIT}
#      COMMAND "grep git-svn-id"
#      COMMAND sed -re "s/^\\s*git-svn-id: .*@([0-9]+).*$/\\1/"
      WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
      OUTPUT_VARIABLE SVN_COMMIT
      ERROR_VARIABLE Project_WC_REVISION_error
      RESULT_VARIABLE Project_WC_REVISION_result)
    if ( NOT ${Project_WC_REVISION_result} EQUAL 0 )
      MESSAGE(SEND_ERROR "Command \"git show --raw ${GIT_COMMIT}\" failed with output:\n${Project_WC_REVISION_error}")
    endif()
    string(REGEX REPLACE ".*git-svn-id: .*trunk@([0-9]+) .*" "\\1"Project_WC_REVISION ${SVN_COMMIT})
    MESSAGE(STATUS "Current SVN(git) revision is ${Project_WC_REVISION}")
  endif()
ENDIF()

set(FEELPP_VERSION_MAJOR "0")
set(FEELPP_VERSION_MINOR "91")
set(FEELPP_VERSION_MICRO "1")
set(FEELPP_REVISION "0" )
set(FEELPP_BUILDID "0" )
if ((FEELPP_ENABLE_SVN AND Subversion_FOUND AND EXISTS ${PROJECT_SOURCE_DIR}/.svn) OR
    (FEELPP_ENABLE_SVN AND GIT_FOUND AND  EXISTS ${PROJECT_SOURCE_DIR}/.git ))
  set(FEELPP_VERSION_EXTRA "~${FEELPP_SCM}${Project_WC_REVISION}")
  set(FEELPP_REVISION "${Project_WC_REVISION}")
  set(FEELPP_BUILDID "${Project_WC_REVISION}")
  file(WRITE "${CMAKE_SOURCE_DIR}/SVNREVISION" "${Project_WC_REVISION}")
else()
  set(FEELPP_VERSION_EXTRA "")
  if ( EXISTS "${CMAKE_SOURCE_DIR}/SVNREVISION" )
    file(READ "${CMAKE_SOURCE_DIR}/SVNREVISION" FEELPP_REVISION)
    file(READ "${CMAKE_SOURCE_DIR}/SVNREVISION" FEELPP_BUILDID)
  endif()
endif()
set(FEELPP_VERSION "(((${FEELPP_VERSION_MAJOR}) << 16) | ((${FEELPP_VERSION_MINOR}) << 9) | (${FEELPP_VERSION_MICRO}))" )
set(FEELPP_VERSION_STRING "${FEELPP_VERSION_MAJOR}.${FEELPP_VERSION_MINOR}.${FEELPP_VERSION_MICRO}${FEELPP_VERSION_EXTRA}")
set(FEELPP_SHARED_VERSION "1.0.0" )
set(FEELPP_SHARED_SOVERSION "1" )

SET(FEELPP_HOME_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")
SET(FEELPP_HOME_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")
SET(FEELPP_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")
SET(FEELPP_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")
SET(FEELPP_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR} CACHE INTERNAL "")

SET( CMAKE_MODULE_PATH  ${FEELPP_HOME_DIR}/cmake/modules )
add_subdirectory(cmake/modules)

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)


if(APPLE)
  set(FEELPP_OS "MacOSX")
elseif(CYGWIN)
  set(FEELPP_OS "Windows")
else(APPLE)
  set(FEELPP_OS "${CMAKE_SYSTEM_NAME}")
endif(APPLE)

if(CMAKE_COMPILER_IS_GNUCXX)
  SET(CMAKE_CXX_FLAGS "-std=c++0x -pedantic  -ftemplate-depth-256 -Wno-inline" CACHE STRING "Default flags" FORCE)
  SET(CMAKE_CXX_FLAGS_DEBUG "-std=c++0x  -pedantic -g  -ftemplate-depth-256 -Wno-inline" CACHE STRING "Debug flags" FORCE)
  SET(CMAKE_CXX_FLAGS_RELEASE "-std=c++0x  -pedantic -g0 -O2 -DNDEBUG  -ftemplate-depth-256 -finline-functions -Wno-inline"  CACHE STRING "Release flags" FORCE)
endif(CMAKE_COMPILER_IS_GNUCXX)

OPTION(FEELPP_ENABLE_MOVE_SEMANTICS "enable move semantics(elision)" ON )
MARK_AS_ADVANCED(FEELPP_ENABLE_MOVE_SEMANTICS)
IF ( FEELPP_ENABLE_MOVE_SEMANTICS )
  SET( BOOST_UBLAS_MOVE_SEMANTICS 1 CACHE STRING "Enable Boost Ublas move semantics" FORCE )
  ADD_DEFINITIONS( -DBOOST_UBLAS_MOVE_SEMANTICS )
ENDIF( FEELPP_ENABLE_MOVE_SEMANTICS )


OPTION(FEELPP_ENABLE_INSTANTIATION_MODE "Instantiation mode" ON )
MARK_AS_ADVANCED(FEELPP_ENABLE_INSTANTIATION_MODE)
IF ( FEELPP_ENABLE_INSTANTIATION_MODE )
  SET( FEELPP_INSTANTIATION_MODE 1 )
ENDIF()

OPTION(FEELPP_ENABLE_MPI_MODE "Instantiation mode" OFF )
IF ( FEELPP_ENABLE_MPI_MODE )
  SET( FEELPP_ENABLE_MPI_MODE 1 )
ENDIF()

OPTION(FEELPP_BENCHMARK_FLAGS "enable benchmarks flags" OFF)
if ( FEELPP_BENCHMARK_FLAGS )
  set(CMAKE_BUILD_TYPE Release )
  set(GCC_PARAM_INLINE_UNIT_GROWTH 150)
  set(GCC_PARAM_MAX_INLINE_INSNS_SINGLE 500)
  set(GCC_PARAM_LARGE_FUNCTION_GROWTH 600)
#  SET(CMAKE_CXX_FLAGS_RELEASE "-Wall -Wshadow -Woverloaded-virtual -std=c++0x -O3 -DNDEBUG --param max-inline-recursive-depth=256 --param max-gcse-memory=8000 --param max-inline-insns-single=${GCC_PARAM} --param inline-unit-growth=${GCC_PARAM} --param large-unit-insns=${GCC_PARAM} --param large-function-growth=${GCC_PARAM} --param large-function-insns=${GCC_PARAM} " CACHE STRING "Benchmarks Release flags" FORCE)
#  SET(CMAKE_CXX_FLAGS_RELEASE "-std=c++0x -O3 -DNDEBUG --param max-inline-recursive-depth=256 --param max-gcse-memory=8000 --param max-inline-insns-single=${GCC_PARAM} --param inline-unit-growth=${GCC_PARAM} --param large-unit-insns=${GCC_PARAM} --param large-function-growth=${GCC_PARAM} --param large-function-insns=${GCC_PARAM} " CACHE STRING "Benchmarks Release flags" FORCE)
  SET(CMAKE_CXX_FLAGS_RELEASE "-std=c++0x -O3 -DNDEBUG --param max-inline-insns-single=${GCC_PARAM_MAX_INLINE_INSNS_SINGLE} --param inline-unit-growth=${GCC_PARAM_INLINE_UNIT_GROWTH} --param large-function-growth=${GCC_PARAM_LARGE_FUNCTION_GROWTH} " CACHE STRING "Benchmarks Release flags" FORCE)
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
  option(FEELPP_ENABLE_SSE2 "Enable/Disable SSE2 in tests/examples" OFF)
  if(FEELPP_ENABLE_SSE2)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
    message(STATUS "Enabling SSE2 in tests/examples")
  endif()

  option(FEELPP_ENABLE_SSE3 "Enable/Disable SSE3 in tests/examples" OFF)
  if(FEELPP_ENABLE_SSE3)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse3")
    message(STATUS "Enabling SSE3 in tests/examples")
  endif()

  option(FEELPP_ENABLE_SSSE3 "Enable/Disable SSSE3 in tests/examples" OFF)
  if(FEELPP_ENABLE_SSSE3)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mssse3")
    message(STATUS "Enabling SSSE3 in tests/examples")
  endif()

  option(FEELPP_ENABLE_SSE4_1 "Enable/Disable SSE4.1 in tests/examples" OFF)
  if(FEELPP_ENABLE_SSE4_1)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.1")
    message(STATUS "Enabling SSE4.1 in tests/examples")
  endif()

  option(FEELPP_ENABLE_SSE4_2 "Enable/Disable SSE4.2 in tests/examples" OFF)
  if(FEELPP_ENABLE_SSE4_2)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.2")
    message(STATUS "Enabling SSE4.2 in tests/examples")
  endif()

  option(FEELPP_ENABLE_ALTIVEC "Enable/Disable AltiVec in tests/examples" OFF)
  if(FEELPP_ENABLE_ALTIVEC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -maltivec -mabi=altivec")
    message(STATUS "Enabling AltiVec in tests/examples")
  endif()

  option(FEELPP_ENABLE_NEON "Enable/Disable Neon in tests/examples" OFF)
  if(FEELPP_ENABLE_NEON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mfloat-abi=softfp -mfpu=neon -mcpu=cortex-a8")
    message(STATUS "Enabling NEON in tests/examples")
  endif()
endif(CMAKE_COMPILER_IS_GNUCXX)
#INCLUDE(PackageArchGlobalMacros)
# INCLUDE(FeelGlobalMacros)
#INCLUDE(AdvancedSet)
#INCLUDE(AdvancedOption)

include(feelpp.extra.warnings)
add_definitions(${FEELPP_FLAGS})

if("${CMAKE_CXX_FLAGS} ${FEELPP_FLAGS}" MATCHES "[^ ]")
  message(STATUS "[feel++] Global flags: ${CMAKE_CXX_FLAGS} ${FEELPP_FLAGS}")
endif()

message(STATUS "[feel++] Debug flags: ${CMAKE_CXX_FLAGS_DEBUG}")
message(STATUS "[feel++] Release flags: ${CMAKE_CXX_FLAGS_RELEASE}")

INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFiles)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckSymbolExists)
INCLUDE(CheckCXXSourceCompiles)
INCLUDE(CheckLibraryExists)
INCLUDE(ParseArguments)

# MACRO(CAR var)
#   SET(${var} ${ARGV1})
# ENDMACRO(CAR)

# MACRO(CDR var junk)
#   SET(${var} ${ARGN})
# ENDMACRO(CDR)
INCLUDE(CheckTypeSize)
CHECK_TYPE_SIZE(int SIZE_INT )
CHECK_TYPE_SIZE(uint SIZE_UINT )
CHECK_TYPE_SIZE(size_t SIZE_SIZE_T )
CHECK_TYPE_SIZE(long SIZE_LONG )
CHECK_TYPE_SIZE(float SIZE_FLOAT )
CHECK_TYPE_SIZE(double SIZE_DOUBLE )
CHECK_TYPE_SIZE("long double" SIZE_LONG_DOUBLE)
MESSAGE(STATUS "SIZE_INT=${SIZE_INT}")
MESSAGE(STATUS "SIZE_UINT=${SIZE_UINT}")
MESSAGE(STATUS "SIZE_SIZE_T=${SIZE_SIZE_T}")
MESSAGE(STATUS "SIZE_LONG=${SIZE_LONG}")
MESSAGE(STATUS "SIZE_FLOAT=${SIZE_FLOAT}")
MESSAGE(STATUS "SIZE_DOUBLE=${SIZE_DOUBLE}")
MESSAGE(STATUS "SIZE_LONG_DOUBLE=${SIZE_LONG_DOUBLE}")


# Find Feel++ or at least it dependencies
FIND_PACKAGE(Feel++ REQUIRED)

option(FEELPP_ENABLE_BAMG "Enable Bamg mesh generator in Feel++" OFF)
if(FEELPP_ENABLE_BAMG)
  add_subdirectory(contrib/bamg)
  include_directories(contrib/bamg contrib/bamg/bamglib)
  set_config_option(FEELPP_HAVE_BAMG "Bamg")
endif(FEELPP_ENABLE_BAMG)


#
# Python
#
FIND_PACKAGE(PythonInterp 2.2 REQUIRED)

#
# data
#
IF(NOT APPLE)
ADD_SUBDIRECTORY ( data )
ENDIF(NOT APPLE)

#
# Feel
#
ADD_SUBDIRECTORY ( feel )




SET(FEELPP_MESH_MAX_ORDER "5" CACHE STRING "maximum geometrical order in templates to instantiate" )

OPTION(FEELPP_ENABLE_DOCUMENTATION "enable Feel++ documentation" ON)

=== feel/CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8 -*-
#
#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-11-29
#
#  Copyright (C) 2009-2010 Université Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#

macro(feel_append_src DIRNAME FILES)
  foreach(FILE ${FILES})
    list(APPEND LIST ${DIRNAME}/${FILE})
  endforeach(FILE)
  set(FEELPP_SRCS ${FEELPP_SRCS};${LIST} PARENT_SCOPE)
  set(FEELPP_DIRS ${FEELPP_DIRS};${DIRNAME} PARENT_SCOPE)
endmacro(feel_append_src)

add_subdirectory (feelcore)
add_subdirectory (feelalg)
add_subdirectory (feelmesh)
add_subdirectory (feelpoly)
add_subdirectory (feelopt)
add_subdirectory (feelcrb)
add_subdirectory (feeldiscr)
add_subdirectory (feelfilters)
add_subdirectory (feelmaterial)
add_subdirectory (feelvf )
#add_subdirectory (feelsystem)

add_library(feel++ SHARED options.cpp ${FEELPP_SRCS})
set_target_properties( feel++ PROPERTIES VERSION ${FEELPP_SHARED_VERSION} SOVERSION ${FEELPP_SHARED_SOVERSION})
set_property(TARGET feel++ PROPERTY LABELS feel++)

#target_link_libraries (feel++ ${PETSC_LIBRARIES} ${Boost_LIBRARIES} ${MPI_LIBRARIES} ${LIBXML2_LIBRARIES} ${TBB_LIBRARIES})
if ( FEELPP_ENABLE_BAMG )
  target_link_libraries (feel++ feel++_bamg ${FEELPP_LIBRARIES})
else()
  target_link_libraries (feel++ ${FEELPP_LIBRARIES})
endif()
set_target_properties(feel++ PROPERTIES VERSION ${FEELPP_SHARED_VERSION} SOVERSION ${FEELPP_SHARED_SOVERSION})

# Install feel++
INSTALL(TARGETS feel++ DESTINATION lib/ COMPONENT Bin)

=== benchmarks/perf/CMakeLists.txt ===
###  CMakeLists.txt ---

#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-12-01
#
#  Copyright (C) 2009 Universit Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
add_custom_target(genfiles ALL)
macro(OVERWITE_IF_DIFFERENT thetarget filename var dummy)
  if ( NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/${filename} )
    # be careful if file does not exist we use dummy to generate the cpp file which will
    # then be overwritten using the cmake -E copy_if_different command
    configure_file(${dummy}  ${CMAKE_CURRENT_BINARY_DIR}/${filename})
  endif()
  file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/copy_${filename} ${var})
  add_custom_command(TARGET ${thetarget} COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${CMAKE_CURRENT_BINARY_DIR}/copy_${filename} ${CMAKE_CURRENT_BINARY_DIR}/${filename}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
endmacro()

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  )

add_executable( feel_perf
  bench1_main.cpp
  bench1_run.cpp
  bench1_run1d.cpp
  bench1_run2d.cpp
  bench1_run3d.cpp
  )
target_link_libraries(feel_perf ${FEELPP_LIBRARIES} )
# add_test( perf COMMAND feel_perf --hsi

add_executable( feel_perf2
  perf2.cpp
  )
target_link_libraries(feel_perf2 ${FEELPP_LIBRARIES} )

add_subdirectory(laplacian)
add_subdirectory(dar)
add_subdirectory(stokes)
add_subdirectory(mortar)

=== doc/manual/CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8 -*-
#
#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-11-29
#
#  Copyright (C) 2009-2010 Université Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} )
include(UseLATEX)

foreach(cppfile "tutorial/*.cpp" "nonlinear/*.cpp" )
 FILE(GLOB CPPFILE RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${cppfile})
 SET(CPPFILES "${CPPFILES};${CPPFILE}")
endforeach()
FILE(GLOB STYFILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "styles/*.sty")

FILE(WRITE version.tex "\\newcommand{\\feelversion}{${FEELPP_VERSION_STRING}}")

FIND_PACKAGE(Subversion)
IF(Subversion_FOUND AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.svn" )
   Subversion_WC_INFO(${PROJECT_SOURCE_DIR} FEEL)
   MESSAGE("Current revision is ${FEELPP_WC_REVISION}")
   MESSAGE("Last changed date is ${FEELPP_WC_LAST_CHANGED_DATE}")

   FILE(APPEND version.tex "\\newcommand{\\feelsvnrevision}{${FEELPP_WC_REVISION}}")
   FILE(APPEND version.tex "\\newcommand{\\feelsvndate}{${FEELPP_WC_LAST_CHANGED_DATE}}")
ENDIF()


add_latex_document(feel-manual.tex
  INPUTS
  tutorial/building.tex
  tutorial/getting-started.tex
  tutorial/feel.tex
  nonlinear/nonlinear.tex
  heatns/natural-convection-2d.tex
  heat/heatsink.tex
  dd/dd.tex
  maxwell/maxwell.tex
  randomnotes.tex gfdl.tex howto.tex version.tex ${CPPFILES} ${STYFILES}
  BIBFILES
  ../biblio/feel-manual.bib
  ../biblio/feelpp.bib
  ../biblio/feelpp-thesis.bib
  IMAGE_DIRS pngs pdfs pngs/mymesh pngs/heatsink
  USE_INDEX
  DEFAULT_PDF
  )
SET_TARGET_PROPERTIES(pdf PROPERTIES EXCLUDE_FROM_ALL true)


# this target allows to create all the required figures for the tutorial
add_custom_target(figures WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/ )

macro( add_docex target )
 add_executable( feel_doc_${target} ${target}.cpp )
 target_link_libraries( feel_doc_${target} ${FEELPP_LIBRARIES} )
 get_target_property(target_executable feel_doc_${target} LOCATION)
 list(APPEND LIST_APPS ${target_executable})
 add_dependencies(figures feel_doc_${target})
 add_dependencies(doc feel_doc_${target})
 if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${target}.cfg)
   configure_file( ${target}.cfg ${target}.cfg)
 endif()
 add_custom_command(
   TARGET figures
   POST_BUILD
   COMMAND ${target_executable} ARGS --shape="simplex" --nochdir > ${CMAKE_CURRENT_BINARY_DIR}/${target}-simplex.out 2>&1
   COMMAND ${target_executable} ARGS --shape="hypercube" --nochdir > ${CMAKE_CURRENT_BINARY_DIR}/${target}-hypercube.out 2>&1
   )
 foreach( dim 1 2 3 )
#   message( STATUS "Generate scripts for graphical results for dimension ${dim}" )
   file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/${target}-simplex-${dim}.pos "Include \"simplex-${dim}.geo\";\n Mesh ${dim}; Include \"tutorial.pos\";\n Exit;\n")
   file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/${target}-hypercube-${dim}.pos "Include \"hypercube-${dim}.geo\";\n Mesh ${dim}; Include \"tutorial.pos\";\n Exit;\n")
   add_custom_command(
     TARGET figures
     POST_BUILD
     COMMAND ${GMSH} ARGS -v 0 ${target}-simplex-${dim}.pos
     COMMAND ${GMSH} ARGS -v 0 ${target}-hypercube-${dim}.pos
   )
 endforeach()
 # test each backend
 foreach( BACKEND ${BACKEND_PETSC} ${BACKEND_TRILINOS})
   add_test( feel_doc_${target}-${BACKEND} feel_doc_${target} --hsize=0.2 --backend=${BACKEND} --no-export)
 endforeach()
 INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/feel_doc_${target} DESTINATION bin/ COMPONENT Bin)
endmacro()

add_custom_target(
  tut-prerequisites
  ALL
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/tutorial.pos
                                   ${CMAKE_CURRENT_BINARY_DIR}/
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)
add_dependencies(tut-prerequisites feel_doc_mymesh)
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/tutorial.pos  ${CMAKE_CURRENT_BINARY_DIR}/tutorial.pos)

if ( NOT FEELPP_MINIMAL_CONFIGURATION )

# # foreach( docex  myintegrals mymesh geotool myfunctionspace laplacian loadmesh residualestimator stokes stokes_good stokes_locking stokes_spurious bratu nonlinearpow mortar multi_levels threefields nirb nirbTest)
# #   add_docex( ${docex} )
# # endforeach()

#copy (${FEELPP_SOURCE_DIR}/data/medit/Cylref.mesh ${CMAKE_CURRENT_BINARY_DIR}/)


# Natural convection problem
#include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )
#add_executable( feel_doc_convection convection.hpp convection_other.cpp convection_main.cpp convection_run.cpp convection_residual.cpp convection_jacobian.cpp convection_jacobian1.cpp convection_jacobian2.cpp convection_lo.cpp convection_lo2.cpp )
#target_link_libraries( feel_doc_convection ${FEELPP_LIBRARIES} )



endif ( NOT FEELPP_MINIMAL_CONFIGURATION )

set(FEELPP_INSTALL_APPS ${FEELPP_INSTALL_APPS};${LIST_APPS} PARENT_SCOPE)
message(STATUS "doc tutorial: ${LIST_APPS}")


IF ( OCTAVE_FOUND )

GET_DIRECTORY_PROPERTY(cmake_include_directories INCLUDE_DIRECTORIES)
SET(octave_include_dirs)
FOREACH(it ${cmake_include_directories})
  SET(octave_include_dirs ${octave_include_dirs} "-I${it}")
ENDFOREACH(it)

add_custom_target(octave WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/ )

macro(add_octave_module modulename)

  foreach( dim 2 )
    foreach( order 1 2 )
      FILE(WRITE ${CMAKE_CURRENT_BINARY_DIR}/${modulename}_${dim}_${order}_oct.cpp "#include<${modulename}_oct.hpp>\n\n RESIDUAL_ESTIMATOR( ${dim}, ${order} )\n" )

      add_library( ${modulename}_${dim}_${order}.oct MODULE  EXCLUDE_FROM_ALL ${modulename}_${dim}_${order}_oct.cpp  )
      add_dependencies(${modulename}_${dim}_${order}.oct
        ${CMAKE_CURRENT_SOURCE_DIR}/${modulename}_oct.hpp
        ${CMAKE_CURRENT_SOURCE_DIR}/${modulename}.hpp
        )
      add_dependencies(octave ${modulename}_${dim}_${order}.oct)
      target_link_libraries( ${modulename}_${dim}_${order}.oct ${FEELPP_LIBRARIES} ${Octave_LIBRARIES})
      set_target_properties( ${modulename}_${dim}_${order}.oct PROPERTIES PREFIX "" )
      set_target_properties( ${modulename}_${dim}_${order}.oct PROPERTIES SUFFIX "" )
    endforeach( order )
  endforeach( dim )
  configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/${modulename}.m  ${CMAKE_CURRENT_BINARY_DIR}/residualestimator.m)
endmacro(add_octave_module)




ENDIF( OCTAVE_FOUND )

add_subdirectory(tutorial)

if (NOT FEELPP_MINIMAL_CONFIGURATION)
  add_subdirectory(dd)
  #add_subdirectory(heat)
  #add_subdirectory(heatns)
  add_subdirectory(nonlinear)
  add_subdirectory(adapt)
  add_subdirectory(nirb)
  add_subdirectory(mcs)
endif()

=== debian/changelog ===
feel++ (0.91.1-2) unstable; urgency=low

  * Fix  conflicting installation of cmake files (Closes: 664594)

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 20 Mar 2012 05:56:30 +0100

feel++ (0.91.1-1) unstable; urgency=low

  * New upstream release

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 18 Mar 2012 17:02:49 +0100

=== debian/control ===
Source: feel++
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>
Build-Depends: cdbs, quilt, debhelper (>= 7), cmake (>=2.6), g++ (>=4.5), gfortran (>=4.5),
	       libboost-all-dev, libboost-mpi-dev,
	       mpi-default-dev[!hurd-i386], mpi-default-bin[!hurd-i386],
	       libtrilinos-dev[!armel !mips !mipsel !s390 !hppa !hurd-i386 !sparc],
	       libpetsc3.2-dev, libslepc3.2-dev,
	       libhdf5-mpi-dev,
	       libsuperlu3-dev, libsuitesparse-dev, libscotchmetis-dev,
	       python-pyx, python-scipy,
	       libxml2-dev,
	       gmsh, 
               doxygen, doxygen-latex,
	       transfig,imagemagick,
	       libtbb-dev[amd64 i386],
	       libopenturns-dev, openturns-wrapper, libann-dev, libglpk-dev 
Standards-Version: 3.9.2
Homepage: http://www.feelpp.org
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/feel++/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/feel++/trunk


Package: libfeel++1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gmsh, mpi-default-bin
Replaces: liblife
Description: A library for the finite element method
 This package provides the dynamic Feel++ libraries.
 .
 Feel++ is a versatile finite element library to solve partial
 differential equations.
 .
 Support 1D, 2D, 3D
 .
 Support the following basic entities: simplices (segment, triangle,
 tetrahedron) and product of simplices (quadrangle, hexahedron)
 .
 Support various point sets on these basic entities: equispaced
 points, quadrature points, interpolation points (Gauss-Lobatto,
 Fekete, WarpBlend?)
 .
 Support continuous and discontinuous Galerkin methods
 .
 Support various polynomial sets:
 .
  * Lagrange(continuous,discontinuous,all dimensions,all interpolation
 point sets)
 .
  * Dubiner(discontinuous), boundary adapted(continuous)
 .
  * Legendre(discontinuous), boundary adapted(continuous)
 .
 Provide mathematical concept for higher order abstraction (Function
 spaces and associated elements, forms and operators)
 .
 Provide a language embedded in C++ for variational formulations,
 projection and numerical integration


Package: libfeel++-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfeel++1 (= ${binary:Version}), libvtk5-dev, 
	 libboost1.46-all-dev|libboost-all-dev, libboost-mpi1.46-dev |libboost-mpi-dev,
	 mpi-default-dev, mpi-default-bin,
         libtrilinos-dev, libpetsc3.2-dev,  libslepc3.2-dev, libgmm++-dev,
         libsuperlu3-dev, libsuitesparse-dev, libscotchmetis-dev,
	 libeigen2-dev, libvtk5-dev, libxml2-dev, libtbb-dev [amd64 i386],
         libopenturns-dev, openturns-wrapper, libann-dev, libglpk-dev
Suggests: feel++-doc, libfeel++-dbg, doxygen, octave3.2-headers
Replaces: liblife-dev
Description: A library for the finite element method
 This package provides the header files and static libraries.
 .
 Feel++ is a versatile finite element library to solve partial
 differential equations.
 .
 Support 1D, 2D, 3D
 .
 Support the following basic entities: simplices (segment, triangle,
 tetrahedron) and product of simplices (quadrangle, hexahedron)
 .
 Support various point sets on these basic entities: equispaced
 points, quadrature points, interpolation points (Gauss-Lobatto,
 Fekete, WarpBlend?)
 .
 Support continuous and discontinuous Galerkin methods
 .
 Support various polynomial sets:
 .
  * Lagrange(continuous,discontinuous,all dimensions,all interpolation
 point sets)
 .
  * Dubiner(discontinuous), boundary adapted(continuous)
 .
  * Legendre(discontinuous), boundary adapted(continuous)
 .
 Provide mathematical concept for higher order abstraction (Function
 spaces and associated elements, forms and operators)
 .
 Provide a language embedded in C++ for variational formulations,
 projection and numerical integration

Package: libfeel++-dbg
Section: debug
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfeel++-dev, libtbb2-dbg [amd64 i386]
Replaces: liblife-dbg
Description: A library for the finite element method
 Feel++ is a versatile finite element library to solve partial
 differential equations
 .
 Support 1D, 2D, 3D
 .
 Support the following basic entities: simplices (segment, triangle,
 tetrahedron) and product of simplices (quadrangle, hexahedron)
 .
 Support various point sets on these basic entities: equispaced
 points, quadrature points, interpolation points (Gauss-Lobatto,
 Fekete, WarpBlend?)
 .
 Support continuous and discontinuous Galerkin methods
 .
 Support various polynomial sets:
 .
  * Lagrange(continuous,discontinuous,all dimensions,all interpolation
 point sets)
 .
  * Dubiner(discontinuous), boundary adapted(continuous)
 .
  * Legendre(discontinuous), boundary adapted(continuous)
 .
 Provide mathematical concept for higher order abstraction (Function
 spaces and associated elements, forms and operators)
 .
 Provide a language embedded in C++ for variational formulations,
 projection and numerical integration

Package: feel++-apps
Section: science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfeel++1 (= ${binary:Version}), gmsh
Recommends: paraview
Replaces: life-apps
Description: A library for the finite element method
 This package provides some applications codes(source and executables) such
 as laplacian with cG and dG methods, stokes, heat transfer, solid
 mechanics(static and dynamic).
 .
 Feel++ is a versatile finite element library to solve partial
 differential equations
 .
 Support 1D, 2D, 3D
 .
 Support the following basic entities: simplices (segment, triangle,
 tetrahedron) and product of simplices (quadrangle, hexahedron)
 .
 Support various point sets on these basic entities: equispaced
 points, quadrature points, interpolation points (Gauss-Lobatto,
 Fekete, WarpBlend?)
 .
 Support continuous and discontinuous Galerkin methods
 .
 Support various polynomial sets:
 .
  * Lagrange(continuous,discontinuous,all dimensions,all interpolation
 point sets)
 .
  * Dubiner(discontinuous), boundary adapted(continuous)
 .
  * Legendre(discontinuous), boundary adapted(continuous)
 .
 Provide mathematical concept for higher order abstraction (Function
 spaces and associated elements, forms and operators)
 .
 Provide a language embedded in C++ for variational formulations,
 projection and numerical integration

Package: feel++-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: life-doc
Description: A library for the finite element method
 This package provides the documentation for the Feel++ library : a user
 guide including a tutorial and the api documentation generated by
 doxygen.
 .
 Feel++ is a versatile finite element library to solve partial
 differential equations.
 .
 Support 1D, 2D, 3D
 .
 Support the following basic entities: simplices (segment, triangle,
 tetrahedron) and product of simplices (quadrangle, hexahedron)
 .
 Support various point sets on these basic entities: equispaced
 points, quadrature points, interpolation points (Gauss-Lobatto,
 Fekete, WarpBlend?)
 .
 Support continuous and discontinuous Galerkin methods
 .
 Support various polynomial sets:
 .
  * Lagrange(continuous,discontinuous,all dimensions,all interpolation
 point sets)
 .
  * Dubiner(discontinuous), boundary adapted(continuous)
 .
  * Legendre(discontinuous), boundary adapted(continuous)
 .
 Provide mathematical concept for higher order abstraction (Function
 spaces and associated elements, forms and operators)
 .
 Provide a language embedded in C++ for variational formulations,
 projection and numerical integration
